import * as Backbone from 'backbone';
import { model, url } from './decorators';


class Post extends Backbone.Model {
  comments = new Comments([], { post: this });
  constructor(attributes, options) {
    super(attributes, options);
  }
}

@model(Post)
@url('/posts')
class Posts extends Backbone.Collection {
  constructor() {
    super();
  }
}

class Comment extends Backbone.Model {
  constructor(attributes, options) {
    super(attributes, options);
  }
}

@model(Comment)
class Comments extends Backbone.Collection {
  constructor(models, {post}) {
    super(models);
    this.post = post;
  }
  url() {
    let url = this.post.url();
    return `${url}/comments`;
  }
}

export {
  Post,
  Posts,
  Comment,
  Comments
}
